Quote:
|
Originally Posted by falko
What's in /etc/init.d/fetchmail?
|
#!/bin/sh
#
# Fetchmail init script
# Latest change: Do Jun 23 16:59:08 CEST 2005
#
# A fetchmailrc file containg hosts and passwords for all local users should be
# placed in /etc/fetchmailrc. Remember to make the /etc/fetchmailrc mode 600
# to avoid disclosing the users' passwords.
#
# This script will NOT start or stop fetchmail if the /etc/fetchmailrc file
# does not exist.
#
set -e
if [ ! -e /etc/fetchmailrc ]; then
exit 0
fi
test -f /etc/default/fetchmail || exit 0
. /etc/default/fetchmail
if [ ! "x$START_DAEMON" = "xyes" ]; then
echo "Edit /etc/default/fetchmail to start fetchmail"
exit 0
fi
# Defaults
PATH=/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/bin/fetchmail
USER=fetchmail
CONFFILE=/etc/fetchmailrc
OPTIONS="-f $CONFFILE"
PIDFILE="`getent passwd $USER | awk -F: '{ print $6 }'`/.fetchmail.pid"
UIDL=/var/lib/fetchmail/.fetchmail-UIDL-cache
test -f $DAEMON || exit 0
test -r $CONFFILE || exit 0
. /lib/lsb/init-functions
if [ "$1" = "start" ]; then
if [ ! -r $CONFFILE ] ; then
echo "$CONFFILE not found."
echo "can not start fetchmail daemon... consider disabling the script"
exit 0
fi
fi
# sanity checks (saves on MY sanity :-P )
if ! id $USER >/dev/null 2>&1; then
if [ "$USER" = "fetchmail" ]; then
# The fetchmail user might have been removed when the fetchmail-common
# package is purged. We have to re-add it here so the system-wide
# daemon will run.
adduser --system --ingroup nogroup --home /var/lib/fetchmail \
--shell /bin/sh --disabled-password fetchmail >/dev/null 2>&1 || true
# work around possible adduser bug, see #119366
[ -d /var/lib/fetchmail ] || mkdir -p /var/lib/fetchmail
chmod 700 /var/lib/fetchmail
chown -h -R fetchmail:nogroup /var/lib/fetchmail
else
log_failure_msg "$USER user does not exist!"
exit 1
fi
fi
# add daemon option if user hasn't already specified it
if ! grep -qs '^[[:space:]]*set[[:space:]]\+daemon[[:space:]]' "$CONFFILE"; then
OPTIONS="$OPTIONS -d 300"
fi
# add syslog option unless user specified "set no syslog".
if ! grep -qs '^[[:space:]]*set[[:space:]]\+no[[:space:]]\+syslog' "$CONFFILE"; then
OPTIONS="$OPTIONS --syslog"
fi
# support for ephemeral /var/run
#if [ "${PIDFILE%/*}" = "/var/run/fetchmail" ] && [ ! -d ${PIDFILE%/*} ]; then
# mkdir /var/run/fetchmail
# chown -h $USER:nogroup /var/run/fetchmail
# chmod 700 /var/run/fetchmail
#fi
# sanity check
#if [ ! -d ${PIDFILE%/*} ]; then
# echo "$0: directory ${PIDFILE%/*} does not exist!"
# exit 1
#fi
# If the user is going to use a UIDL cache, try to find a better place for the
# UIDL cache than root's homedir. Also create $UIDL if it doesn't exist,
# because the daemon won't have the permission.
if ! grep -qs idfile "$CONFFILE" && [ -d /var/lib/fetchmail ]; then
OPTIONS="$OPTIONS -i $UIDL"
touch $UIDL
chown -h $USER $UIDL
chmod 0600 $UIDL
fi
# Makes sure certain files/directories have the proper owner
if [ "`stat -c '%U %a' $CONFFILE 2>/dev/null`" != "$USER 600" ]; then
chown -h $USER $CONFFILE
chmod -f 0600 $CONFFILE
fi
case "$1" in
start)
if test -e $PIDFILE ; then
pid=`cat $PIDFILE | sed -e 's/\s.*//'`
if kill -0 $pid ; then
echo "Fetchmail already running with pid $pid (or stale pidfile)."
exit 0
fi
fi
log_begin_msg "Starting mail retrieval agent..."
start-stop-daemon -S -o -q -p $PIDFILE -x $DAEMON -u $USER -a /bin/su -- -c "$DAEMON $OPTIONS" $USER
log_end_msg $?
;;
stop)
if ! test -e $PIDFILE ; then
echo "Pidfile not found! Is fetchmail running?"
exit 0
fi
log_begin_msg "Stopping mail retrieval agent..."
start-stop-daemon -K -o -q -p $PIDFILE -x $DAEMON -u $USER
log_end_msg $?
;;
force-reload|restart)
sh $0 stop
sh $0 start
;;
try-restart)
if start-stop-daemon -S -t -q -p $PIDFILE -x $DAEMON -u $USER >/dev/null; then
exit 0
fi
$0 restart
;;
awaken)
log_begin_msg "Awakening mail retrieval agent..."
if [ -r $PIDFILE ]; then
su -c $DAEMON $USER <&- >/dev/null 2>&1
log_end_msg 0
exit 0
else
log_end_msg 1
exit 1
fi
;;
debug-run)
log_success_msg "Initiating debug run of system-wide fetchmail service..." 1>&2
log_success_msg "script will be run in debug mode, all output to forced to" 1>&2
log_success_msg "stdout. This is not enough to debug failures that only" 1>&2
log_success_msg "happen in daemon mode." 1>&2
log_success_msg "You might want to direct output to a file, and tail -f it." 1>&2
if [ "$2" = "strace" ]; then
log_success_msg "(running debug mode under strace. See strace(1) for options)" 1>&2
log_success_msg "WARNING: strace output may contain security-sensitive info, such as" 1>&2
log_success_msg "passwords; please clobber them before sending the strace file to a" 1>&2
log_success_msg "public bug tracking system, such as Debian's." 1>&2
fi
log_success_msg "Stopping the service..." 1>&2
"$0" stop
log_success_msg "exit status of service stop was: $?"
log_success_msg "RUNUSER is $USER"
log_success_msg "OPTIONS would be $OPTIONS"
log_success_msg "Starting service in nodetach mode, hit ^C (SIGINT/intr) to finish run..." 1>&2
if [ "$2" = "strace" ] ; then
shift
shift
[ $# -ne 0 ] && log_success_msg "(strace options are: -tt $@)" 1>&2
su -c "/usr/bin/strace -tt $@ $DAEMON $OPTIONS --nosyslog --nodetach -v -v" $USER <&- 2>&1 && true
else
su -c "$DAEMON $OPTIONS --nosyslog --nodetach -v -v" $USER <&- 2>&1 && true
fi
log_success_msg "End of service run. Exit status was: $?"
exit 0
;;
*)
log_success_msg "Usage: /etc/init.d/fetchmail {start|stop|restart|force-reload|awaken|debug-run}"
log_success_msg " start - starts system-wide fetchmail service"
log_success_msg " stop - stops system-wide fetchmail service"
log_success_msg " restart, force-reload - starts a new system-wide fetchmail service"
log_success_msg " awaken - tell system-wide fetchmail to start a poll cycle immediately"
log_success_msg " debug-run [strace [strace options...]] - start a debug run of the"
log_success_msg " system-wide fetchmail service, optionally running it under strace"
exit 1
;;
esac
exit 0
# vim:ts=4:sw=4:
Recent comments
1 day 39 min ago
1 day 3 hours ago
1 day 15 hours ago
1 day 17 hours ago
1 day 21 hours ago
2 days 4 hours ago
2 days 13 hours ago
2 days 15 hours ago
2 days 23 hours ago
3 days 53 min ago